<template>
  <div>
    <!--Stats cards-->
    <div class="row">
      <div class="col-lg-4 col-sm-4 text-center">
        <stats-card>
          <div class="icon-big text-center icon-info" slot="header">
            <i class="fa fa-users"></i>
          </div>
          <div class="numbers" slot="content">
            <p>Obligados</p>
            {{obligados}}
          </div>
        </stats-card>
      </div>
      <div class="col-lg-4 col-sm-4 text-center">
        <stats-card>
          <div class="icon-big text-center icon-success" slot="header">
            <i class="fa fa-file"></i>
          </div>
          <div class="numbers" slot="content">
            <p>Declaraciones</p>
            {{declaraciones}}
          </div>
        </stats-card>
      </div>
      <div class="col-lg-4 col-sm-4 text-center">
        <stats-card>
          <div class="icon-big text-center icon-danger" slot="header">
            <i class="fa fa-users"></i>
          </div>
          <div class="numbers" slot="content">
            <p>Faltantes</p>
            {{faltantes}}
          </div>
        </stats-card>
      </div>
    </div>
    <div class="row">
      <div class="col-md-8">
        <div class="card card-circle-chart">
          <div class="card-header">
            <h4 class="card-title">Declaraciones por día</h4>
            <p class="category">Se muestra la última semana</p>
          </div>
          <div class="card-content">
            <div id="chartStock" class="ct-chart"></div>
          </div>
        </div>
      </div>
      <div class="col-md-4" @click="cumplimiento">
        <circle-chart-card :percentage="porcentaje" title="Avance Global" :avance="declaraciones" :total="obligados" description="" @click="cumplimiento">
        </circle-chart-card>
      </div>
    </div>
    <div class="row" v-if="this.getKey('permisos').includes(19)">
      <div class="col-lg-4 col-sm-4 ">
        <a :href="'#/alertas/bitacora'">
          <stats-card>
            <div class="icon-big text-left icon-info" slot="header">
              <i class="fa fa-book"></i>
            </div>
            <div class="numbers titulos" slot="content">
              <p>Bitácora</p>
              <p class="category">Declaraciones Consultadas</p>
            </div>
          </stats-card>
        </a>
      </div>
      <!-- <div class="col-lg-4 col-sm-4 text-center">
        <a :href="'#/alertas/modificadas'">
          <stats-card>
            <div class="icon-big text-center icon-success" slot="header">
              <i class="fa fa-file"></i>
            </div>
            <div class="numbers titulos" slot="content">
              <p>Modificadas</p>
              <p class="category">Declaraciones Reactivadas</p>
            </div>
          </stats-card>
        </a>
      </div> -->
      <div class="col-lg-4 col-sm-4 text-center">
        <a :href="'#/admin/movimientos'">
          <stats-card>
            <div class="icon-big text-center icon-warning" slot="header">
              <i class="fa fa-check-double"></i>
            </div>
            <div class="numbers titulos" slot="content">
              <p>Vo.Bo. Correcciones</p>
              <p class="category">Aprobar Correcciones</p>
            </div>
          </stats-card>
        </a>
      </div>
    </div>
  </div>
</template>
<script>
  import CircleChartCard from 'src/components/UIComponents/Cards/CircleChartCard.vue'
  import StatsCard from 'src/components/UIComponents/Cards/StatsCard.vue'
  import ChartCard from 'src/components/UIComponents/Cards/ChartCard.vue'
  import Loading from 'src/components/Dashboard/Layout/LoadingMainPanel.vue'
  //import chartist_tooltip from 'chartist-plugin-tooltips';
  export default {
    components: {
      StatsCard,
      ChartCard,
      CircleChartCard
    },
    /**
     * Chart data used to render stats, charts. Should be replaced with server data
     */
    data() {
      return {
        //$Chartist: null,
        obligados: '',
        min: 0,
        max: 0,
        faltantes: '',
        porcentaje: 0,
        declaraciones: '',
        plugins: null
      }
    },
    watch: {
      '$route': 'checkPermissions'
    },
    methods: {
      checkPermissions() {
        if (!(this.getKey('role') != 0)) {
          localStorage.clear();
          this.$router.push('/login');
          this.$router.go();
        }
      },
      initStockChart() {
        const dataStock = {
          labels: [],
          series: [
            []
          ]
        }
        const optionsStock = {
          lineSmooth: false,
          axisY: {
            offset: 40,
            labelInterpolationFnc(value) {
              return `${value}`
            }
          },
          low: this.min,
          height: '260px',
          high: this.max,
          classNames: {
            point: 'ct-point ct-green',
            line: 'ct-line ct-green'
          },
          //plugins: [this.$Chartist.plugins.tooltip()]
        }
        const temp = [];
        this.$http.get("semana").then(response => {
          $.each(response.data, function (key, value) {
            dataStock.labels.push(value.date);
            temp.push(value.total);
          });
          dataStock.series[0] = temp;
          dataStock.labels.reverse()
          dataStock.series[0].reverse()
          //this.$Chartist.Line('#chartStock', dataStock, optionsStock)
        }, error => {
          this.StepError(error);
        });
      },
      getDatos() {
        this.$http.get("tableroGlobales").then(response => {
          this.faltantes = Number(response.data.faltantes).toLocaleString().replace('.', ',')
          this.declaraciones = Number(response.data.declaraciones).toLocaleString().replace('.', ',')
          this.obligados = Number(response.data.declarantes).toLocaleString().replace('.', ',')
          this.porcentaje = parseFloat((response.data.porcentaje).toString().substring(0, 5));
        }, error => {
          this.StepError(error);
        });
      },
      cumplimiento() {
        this.$router.push('/reportes/cumplimiento');
      }
    },
    created() {
      this.checkPermissions()
      this.getDatos()
      if (this.getKey('permisos').includes(18)) {
        this.min = 10;
        this.max = 1600;
      } else {
        this.min = 0;
        this.max = 500;
      }
    },
    async mounted() {
      //const Chartist = await import('chartist')
      //this.$Chartist = Chartist
      //this.initStockChart()
      //this.plugins = [this.$Chartist.plugins.tooltip()]
    },
    mounted() {
      this.checkCatalogs();
    }
  }

</script>
<style>
  .chartist-tooltip {
    position: absolute !important;
    background: rgba(0, 0, 0, 0.6) !important;
    color: white !important;
    padding: 0px 10px !important;
    border-radius: 5px !important;
  }

  .titulos {
    text-align: left !important;
  }

</style>
